# Class BigInteger

java.lang.Object
com.codename1.util.BigInteger

public class BigInteger extends Object
A simplified version of big integer from the bouncy castle implementation

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final BigInteger`
  `ONE`
  `static final BigInteger`
  `ZERO`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BigInteger(byte[] bval)`
  `BigInteger(int sign, byte[] mag)`
  `BigInteger(int bitLength, int certainty, Random rnd)`
  `BigInteger(int numBits, Random rnd)`
  `BigInteger(String sval)`
  `BigInteger(String sval, int rdx)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BigInteger`
  `abs()`
  `BigInteger`
  `add(BigInteger val)`
  `BigInteger`
  `and(BigInteger value)`
  `BigInteger`
  `andNot(BigInteger value)`
  `int`
  `bitCount()`
  `int`
  `bitLength()`
  `byte`
  `byteValue()`
  `BigInteger`
  `clearBit(int n)`
  `int`
  `compareTo(BigInteger val)`
  `int`
  `compareTo(Object o)`
  `BigInteger`
  `divide(BigInteger val)`
  `BigInteger[]`
  `divideAndRemainder(BigInteger val)`
  `boolean`
  `equals(Object val)`
  Indicates whether some other object is "equal to" this one.
  `BigInteger`
  `flipBit(int n)`
  `BigInteger`
  `gcd(BigInteger val)`
  `int`
  `getLowestSetBit()`
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `int`
  `intValue()`
  `boolean`
  `isProbablePrime(int certainty)`
  return whether or not a BigInteger is probably prime with a probability of 1 - (1/2)**certainty.
  `long`
  `longValue()`
  `BigInteger`
  `max(BigInteger val)`
  `BigInteger`
  `min(BigInteger val)`
  `BigInteger`
  `mod(BigInteger m)`
  `BigInteger`
  `modInverse(BigInteger m)`
  `BigInteger`
  `modPow(BigInteger exponent, BigInteger m)`
  `BigInteger`
  `multiply(BigInteger val)`
  `BigInteger`
  `negate()`
  `BigInteger`
  `not()`
  `BigInteger`
  `or(BigInteger value)`
  `BigInteger`
  `pow(int exp)`
  `static BigInteger`
  `probablePrime(int bitLength, Random random)`
  `BigInteger`
  `remainder(BigInteger n)`
  `BigInteger`
  `setBit(int n)`
  `BigInteger`
  `shiftLeft(int n)`
  `BigInteger`
  `shiftRight(int n)`
  `int`
  `signum()`
  `BigInteger`
  `subtract(BigInteger val)`
  `boolean`
  `testBit(int n)`
  `byte[]`
  `toByteArray()`
  `String`
  `toString()`
  Returns a string representation of the object.
  `String`
  `toString(int rdx)`
  `static BigInteger`
  `valueOf(long val)`
  `BigInteger`
  `xor(BigInteger val)`

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  `final Class`
  `getClass()`
  Returns the runtime class of an object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes current thread to wait until another thread invokes the method or the method for this object.
  `final void`
  `wait(long timeout)`
  Causes current thread to wait until either another thread invokes the method or the method for this object, or a specified amount of time has elapsed.
  `final void`
  `wait(long timeout, int nanos)`
  Causes current thread to wait until another thread invokes the method or the method for this object, or some other thread interrupts the current thread, or a certain amount of real time has elapsed.

- ## Field Details

  - ### ZERO

    public static final BigInteger ZERO

  - ### ONE

    public static final BigInteger ONE

- ## Constructor Details

  - ### BigInteger

    public BigInteger(String sval) throws NumberFormatException
    Throws:
      `NumberFormatException`

  - ### BigInteger

    public BigInteger(String sval, int rdx) throws NumberFormatException
    Throws:
      `NumberFormatException`

  - ### BigInteger

    public BigInteger(byte[] bval) throws NumberFormatException
    Throws:
      `NumberFormatException`

  - ### BigInteger

    public BigInteger(int sign, byte[] mag) throws NumberFormatException
    Throws:
      `NumberFormatException`

  - ### BigInteger

    public BigInteger(int numBits, Random rnd) throws IllegalArgumentException
    Throws:
      `IllegalArgumentException`

  - ### BigInteger

    public BigInteger(int bitLength, int certainty, Random rnd) throws ArithmeticException
    Throws:
      `ArithmeticException`

- ## Method Details

  - ### probablePrime

    public static BigInteger probablePrime(int bitLength, Random random)

  - ### valueOf

    public static BigInteger valueOf(long val)

  - ### abs

    public BigInteger abs()

  - ### add

    public BigInteger add(BigInteger val) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### and

    public BigInteger and(BigInteger value)

  - ### andNot

    public BigInteger andNot(BigInteger value)

  - ### bitCount

    public int bitCount()

  - ### bitLength

    public int bitLength()

  - ### compareTo

    public int compareTo(Object o)

  - ### compareTo

    public int compareTo(BigInteger val)

  - ### divide

    public BigInteger divide(BigInteger val) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### divideAndRemainder

    public BigInteger[] divideAndRemainder(BigInteger val) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### equals

    public boolean equals(Object val)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### gcd

    public BigInteger gcd(BigInteger val)

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### intValue

    public int intValue()

  - ### byteValue

    public byte byteValue()

  - ### isProbablePrime

    public boolean isProbablePrime(int certainty)

    return whether or not a BigInteger is probably prime with a probability of 1 - (1/2)**certainty.

    From Knuth Vol 2, pg 395.

  - ### longValue

    public long longValue()

  - ### max

    public BigInteger max(BigInteger val)

  - ### min

    public BigInteger min(BigInteger val)

  - ### mod

    public BigInteger mod(BigInteger m) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### modInverse

    public BigInteger modInverse(BigInteger m) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### modPow

    public BigInteger modPow(BigInteger exponent, BigInteger m) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### multiply

    public BigInteger multiply(BigInteger val)

  - ### negate

    public BigInteger negate()

  - ### not

    public BigInteger not()

  - ### pow

    public BigInteger pow(int exp) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### remainder

    public BigInteger remainder(BigInteger n) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### shiftLeft

    public BigInteger shiftLeft(int n)

  - ### shiftRight

    public BigInteger shiftRight(int n)

  - ### signum

    public int signum()

  - ### subtract

    public BigInteger subtract(BigInteger val)

  - ### toByteArray

    public byte[] toByteArray()

  - ### xor

    public BigInteger xor(BigInteger val)

  - ### or

    public BigInteger or(BigInteger value)

  - ### setBit

    public BigInteger setBit(int n) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### clearBit

    public BigInteger clearBit(int n) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### flipBit

    public BigInteger flipBit(int n) throws ArithmeticException
    Throws:
      `ArithmeticException`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`

  - ### toString

    public String toString(int rdx)

  - ### getLowestSetBit

    public int getLowestSetBit()

  - ### testBit

    public boolean testBit(int n) throws ArithmeticException
    Throws:
      `ArithmeticException`